//=========================================================
// src/Temperature_Regulator_main.c: generated by Hardware Configurator
//
// This file will be updated when saving a document.
// leave the sections inside the "$[...]" comment tags alone
// or they will be overwritten!!
//=========================================================

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <SI_EFM8BB1_Register_Enums.h>
#include <InitDevice.h>
#include <defs.h>
#include <adc.h>
#include <regulation.h>
#include <utils.h>
#include <variables.h>
#include <flash.h>
#include <params.h>

//-----------------------------------------------------------------------------
// Variables
//-----------------------------------------------------------------------------
//u8 data pwm;
u16 count;
u16 time;
s16 data temp;
u8 send = 0;
u8 digit = 0;

u16 tmax = 0;
u16 countmax = 0;
u16 filt;
u16 tempraw;
u16 tempfilt;

u8 xdata txBuf[25];
u8 xdata txCursor = 0;

//-----------------------------------------------------------------------------
// Functions
//-----------------------------------------------------------------------------
int main (void)
{
	enter_DefaultMode_from_RESET();

  //TMR2CN0 &= ~(TMR2CN0_TR2__RUN);
	Flash_MemoryErase();
	Params_Init();

	reg_par.curr_OutMin = 100;
	reg_par.curr_OutMax = 60025;


  /*Params_Store();*/

/*pidTemp.inter.diff = 0;
  pidTemp.inter.measOld = 0;
  pidTemp.inter.integ = 0;
  pidTemp.inter.outLimErr = 0;

  pidTemp.param.Kdl = 50;
  pidTemp.param.fSamp = 1;
  pidTemp.param.Kw = 50;
  pidTemp.param.Ki = 100;
  pidTemp.param.Kd = 5000;
  pidTemp.param.Kp = 4000;

  pidTemp.param.outMax = 64520;
  pidTemp.param.outMin = 0;
  pidTemp.param.outMinHalf = 0;*/

  //pidTemp.ref = 10240; /* 40 degC */

  /*
	for(count = 0; count < 65000; count++)
  {
		TMR2 = 0x0000;
		TMR2CN0 |= TMR2CN0_TR2__RUN;
		pidUpdate(&pidCurr);
  	TMR2CN0 &= ~TMR2CN0_TR2__RUN;
  	time = TMR2;
  	time -= 3;
		if(time > tmax)
  	{
  		tmax = time;
  		countmax = count;
  	}
  }*/

  //PWMEnable; // Enable FET driver
  PCA0CPM0 |= PCA0CPM0_ECOM__ENABLED;
  PCA0CPH0 = 0;

  RedON();

  //initInputFilter();

  /* CRC test */
  /*CRC0CN0 |= CRC0CN0_CRCINIT__INIT;
  CRC0IN = 0x00;
  CRC0IN = 0x00;
  CRC0IN = 0xAA;
  CRC0IN = 0xBB;
  CRC0IN = 0xCC;

  CRC0CN0 &= ~CRC0CN0_CRCPNT__BMASK;

  crc[0] = CRC0DAT;
  crc[1] = CRC0DAT;
  */
  while (1) 
  {
  	if((send == 1) && (txCursor == 0))
  	{
  		temp2str(T_zen, (&txBuf));
			SCON0_TI = 1;
  	}
  }                             
}
